## harec 0.24.2

=== Makefile ===
.POSIX:

all:

include config.mk
include makefiles/$(PLATFORM).mk
include makefiles/tests.mk

all: $(BINOUT)/harec

C_DEFINES = \
	-DVERSION='"'"$(VERSION)"'"' \
	-DDEFAULT_TARGET='"$(DEFAULT_TARGET)"'

headers = \
	include/ast.h \
	include/check.h \
	include/emit.h \
	include/eval.h \
	include/expr.h \
	include/gen.h \
	include/identifier.h \
	include/lex.h \
	include/mod.h \
	include/parse.h \
	include/qbe.h \
	include/scope.h \
	include/type_store.h \
	include/typedef.h \
	include/types.h \
	include/utf8.h \
	include/util.h

harec_objects = \
	src/check.o \
	src/emit.o \
	src/eval.o \
	src/expr.o \
	src/gen.o \
	src/genutil.o \
	src/identifier.o \
	src/lex.o \
	src/main.o \
	src/mod.o \
	src/parse.o \
	src/qbe.o \
	src/qinstr.o \
	src/qtype.o \
	src/scope.o \
	src/type_store.o \
	src/typedef.o \
	src/types.o \
	src/utf8.o \
	src/util.o

$(BINOUT)/harec: $(harec_objects)
	@mkdir -p -- $(BINOUT)
	@printf 'CCLD\t%s\n' '$@'
	@$(CC) $(LDFLAGS) -o $@ $(harec_objects) $(LIBS)

.SUFFIXES:
.SUFFIXES: .ha .ssa .td .c .o .s .scd .1 .5

src/check.o: $(headers)
src/emit.o: $(headers)
src/eval.o: $(headers)
src/expr.o: $(headers)
src/gen.o: $(headers)
src/genutil.o: $(headers)
src/identifier.o: $(headers)
src/lex.o: $(headers)
src/main.o: $(headers)
src/mod.o: $(headers)
src/parse.o: $(headers)
src/qbe.o: $(headers)
src/qinstr.o: $(headers)
src/qtype.o: $(headers)
src/scope.o: $(headers)
src/type_store.o: $(headers)
src/typedef.o: $(headers)
src/types.o: $(headers)
src/utf8.o: $(headers)
src/util.o: $(headers)

.c.o:
	@printf 'CC\t%s\n' '$@'
	@$(CC) -c $(CFLAGS) $(C_DEFINES) -o $@ $<

.s.o:
	@printf 'AS\t%s\n' '$@'
	@$(AS) $(ASFLAGS) -o $@ $<

.ssa.s:
	@printf 'QBE\t%s\n' '$@'
	@$(QBE) $(QBEFLAGS) -o $@ $<

.ssa.td:
	@cmp -s $@ $@.tmp 2>/dev/null || cp $@.tmp $@

.ha.ssa:
	@printf 'HAREC\t%s\n' '$@'
	@$(TDENV) $(BINOUT)/harec $(HARECFLAGS) -o $@ $<

clean:
	@rm -rf -- $(HARECACHE) $(BINOUT) $(harec_objects) $(tests)

check: $(BINOUT)/harec $(tests)
	@$(TDENV) ./tests/run

install: $(BINOUT)/harec
	install -Dm755 $(BINOUT)/harec $(DESTDIR)$(BINDIR)/harec

uninstall:
	rm -- '$(DESTDIR)$(BINDIR)/harec'

.PHONY: clean check install uninstall

=== debian/changelog ===
harec (0.24.2-5) unstable; urgency=medium

  * Fix outstanding FTBFS errors on x32 and hurd-amd64 buildd by excluding
    tests from being run on these non-official architectures. Previous
    upload didn't really address this issue.

 -- Miguel Landaeta <nomadium@debian.org>  Tue, 08 Apr 2025 22:59:42 +0100

harec (0.24.2-4) unstable; urgency=medium

  * Address FTBFS errors on x32 and hurd-amd64 buildd by excluding tests
    from being run on these non-official architectures. harec is buildable
    and runnable on those archs but tests will not succeed as they are not
    currently supported by upstream.

 -- Miguel Landaeta <nomadium@debian.org>  Fri, 07 Mar 2025 20:13:04 +0000

harec (0.24.2-3) unstable; urgency=medium

  [ Antonio Terceiro ]
  * Skip tests during build on unsupported target architectures.

  [ Miguel Landaeta ]
  * Fix typo in override_dh_auto_configure target.

 -- Miguel Landaeta <nomadium@debian.org>  Sun, 02 Mar 2025 08:10:08 +0000

harec (0.24.2-2) unstable; urgency=medium

  [ Tobias Heider & Antonio Terceiro ]
  * Fix build config for arch != x86_64.

 -- Miguel Landaeta <nomadium@debian.org>  Tue, 25 Feb 2025 21:49:19 +0000

harec (0.24.2-1) unstable; urgency=medium

  * Initial release. (Closes: #1085046)

 -- Miguel Landaeta <nomadium@debian.org>  Sun, 13 Oct 2024 16:52:29 +0100

=== debian/control ===
Source: harec
Section: devel
Priority: optional
Maintainer: Miguel Landaeta <nomadium@debian.org>
Uploaders: Guilherme Puida Moreira <guilherme@puida.xyz>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 qbe,
 scdoc <!nodoc>,
Standards-Version: 4.7.0
Homepage: https://harelang.org/
Vcs-Browser: https://salsa.debian.org/debian/harec
Vcs-Git: https://salsa.debian.org/debian/harec.git

Package: harec
Architecture: any
Depends:
 qbe,
 ${shlibs:Depends},
 ${misc:Depends},
Description: Hare compiler for POSIX-compatible systems
 Hare is a systems programming language designed to be simple, stable and
 robust. Hare uses a static type system, manual memory management, and a
 minimal runtime. It is well suited to writing operating systems, system
 tools, compilers, networking software, and other low-level, high performance
 tasks.
 .
 This package installs the Hare compiler.

## harec 0.25.2

=== Makefile ===
--- 
+++ 
@@ -59,7 +59,7 @@
 	@$(CC) $(LDFLAGS) -o $@ $(harec_objects) $(LIBS)
 
 .SUFFIXES:
-.SUFFIXES: .ha .ssa .td .c .o .s .scd .1 .5
+.SUFFIXES: .ssa .td .c .o .s
 
 src/check.o: $(headers)
 src/emit.o: $(headers)
@@ -92,14 +92,11 @@
 
 .ssa.s:
 	@printf 'QBE\t%s\n' '$@'
-	@$(QBE) $(QBEFLAGS) -o $@ $<
+	@$(QBE) $(QBEFLAGS) -o $@.tmp $<
+	@mv $@.tmp $@
 
 .ssa.td:
 	@cmp -s $@ $@.tmp 2>/dev/null || cp $@.tmp $@
-
-.ha.ssa:
-	@printf 'HAREC\t%s\n' '$@'
-	@$(TDENV) $(BINOUT)/harec $(HARECFLAGS) -o $@ $<
 
 clean:
 	@rm -rf -- $(HARECACHE) $(BINOUT) $(harec_objects) $(tests)
@@ -108,7 +105,7 @@
 	@$(TDENV) ./tests/run
 
 install: $(BINOUT)/harec
-	install -Dm755 $(BINOUT)/harec $(DESTDIR)$(BINDIR)/harec
+	install -Dm755 -- $(BINOUT)/harec $(DESTDIR)$(BINDIR)/harec
 
 uninstall:
 	rm -- '$(DESTDIR)$(BINDIR)/harec'

=== debian/changelog ===
harec (0.25.2-1) unstable; urgency=medium

  * d/control:
    - Move package to the Debian Hare Team.
    - Apply wrap-and-sort -ast.
    - Bump Standards-Version to 4.7.2, no changes needed.
    - Specify Breaks relationship for hare package.
    - Use my @debian.org mail address.

 -- Guilherme Puida Moreira <puida@debian.org>  Thu, 11 Sep 2025 21:03:39 -0300

=== debian/control ===
Source: harec
Section: devel
Priority: optional
Maintainer: Debian Hare Team <team+pkg-hare@tracker.debian.org>
Uploaders:
 Miguel Landaeta <nomadium@debian.org>,
 Guilherme Puida Moreira <puida@debian.org>,
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 qbe,
 scdoc <!nodoc>,
Standards-Version: 4.7.2
Homepage: https://harelang.org/
Vcs-Browser: https://salsa.debian.org/hare-team/pkg/harec
Vcs-Git: https://salsa.debian.org/hare-team/pkg/harec.git

Package: harec
Architecture: any
Depends:
 qbe,
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 hare (<< ${source:Upstream-Version}),
Description: Hare compiler for POSIX-compatible systems
 Hare is a systems programming language designed to be simple, stable and
 robust. Hare uses a static type system, manual memory management, and a
 minimal runtime. It is well suited to writing operating systems, system
 tools, compilers, networking software, and other low-level, high performance
 tasks.
 .
 This package installs the Hare compiler.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_clean:
	-dh_auto_clean
	-rm -f ./config.mk ./tests/*.o

override_dh_auto_configure:
	sed -e 's/^\s*ARCH\s*=\s.*/ARCH = $(DEB_BUILD_GNU_CPU)/' ./configs/linux.mk > ./config.mk || ($(RM) ./config.mk; false)

override_dh_auto_build:
	dh_auto_build -- VERSION=$(DEB_VERSION)

override_dh_auto_install:
	dh_auto_install -- PREFIX=/usr

override_dh_auto_test:
# On x86_64, run tests only on amd64 (linux), as this is the only linux x86_64
# target supported by upstream.
ifeq (amd64,$(DEB_TARGET_ARCH))
	dh_auto_test
endif
# On non x86_64 archs, run tests only on targets supported by upstream
# (e.g. arm64, riscv64).
ifneq (x86_64,$(DEB_BUILD_GNU_CPU))
	if ! (.bin/harec -a $(DEB_BUILD_GNU_CPU) 2>&1 || true) | grep 'Unsupported or unrecognized target:'; then dh_auto_test; fi
endif

=== debian/watch ===
version=4
opts="uversionmangle=s/-rc/~rc/" \
	https://git.sr.ht/~sircmpwn/@PACKAGE@/refs \
	.*/@ANY_VERSION@@ARCHIVE_EXT@

## harec 0.26.0

=== debian/changelog ===
harec (0.26.0-1) unstable; urgency=medium

  * New upstream release 0.26.0.
  * d/u/metadata: Create file and add Repository/Repository-Browse.
  * d/gbp.conf: Add upstream-vcs-tag.
  * d/control: Bump Standards-Version to 4.7.3. Consequently:
    - d/control: Drop Rules-Require-Root.
  * d/control: Drop optional Priority field.
  * d/watch: Update to version 5.

 -- Guilherme Puida Moreira <puida@debian.org>  Fri, 13 Feb 2026 22:55:08 -0300

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,14 @@
 Source: harec
 Section: devel
-Priority: optional
 Maintainer: Debian Hare Team <team+pkg-hare@tracker.debian.org>
 Uploaders:
  Miguel Landaeta <nomadium@debian.org>,
  Guilherme Puida Moreira <puida@debian.org>,
-Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
  qbe,
  scdoc <!nodoc>,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://harelang.org/
 Vcs-Browser: https://salsa.debian.org/hare-team/pkg/harec
 Vcs-Git: https://salsa.debian.org/hare-team/pkg/harec.git

=== debian/watch ===
Version: 5
Source: https://git.sr.ht/~sircmpwn/harec/refs
Matching-Pattern: .*/@SEMANTIC_VERSION@@ARCHIVE_EXT@
Uversion-Mangle: auto
